# AMD

[![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.3783808.svg)](https://doi.org/10.5281/zenodo.3381898)
[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://JuliaSmoothOptimizers.github.io/AMD.jl/stable)
[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://JuliaSmoothOptimizers.github.io/AMD.jl/dev)
[![CI](https://github.com/JuliaSmoothOptimizers/AMD.jl/workflows/CI/badge.svg?branch=main)](https://github.com/JuliaSmoothOptimizers/AMD.jl/actions)
[![Build Status](https://api.cirrus-ci.com/github/JuliaSmoothOptimizers/AMD.jl.svg)](https://cirrus-ci.com/github/JuliaSmoothOptimizers/AMD.jl)
[![codecov.io](https://codecov.io/github/JuliaSmoothOptimizers/AMD.jl/coverage.svg?branch=main)](https://codecov.io/github/JuliaSmoothOptimizers/AMD.jl?branch=main)

Given a square sparse matrix, compute an approximate minimum degree ordering.
This package is an interface to the AMD library (Amestoy, Davis and Duff) and COLAMD library (Liromore, Davis, Gilberg an Ng).

### Installing

```julia
julia> ]
pkg> add AMD
pkg> test AMD
```

### Algorithms

**amd**: an approximate minimum degree ordering algorithm for the sparse factorization of square matrices.

**symamd**: an approximate minimum degree ordering algorithm for the sparse factorization of symmetric matrices.

**colamd**: an approximate minimum degree column ordering algorithm for the sparse factorization of arbitrary, square or rectangular, matrices.

### Examples

In the simplest case:

```julia
using AMD
A = sprand(10, 10, .5)
p_amd = amd(A)
p_symamd = symamd(A)
p_colamd = colamd(A)
```

If statistics on the permutation are of interest and/or for changing the
default control parameters:

```julia
julia> meta = Amd{Clong}();  # because A's index type is Int64 on my platform
julia> # optionally change meta.control: ?Amd
julia> p = amd(A, meta)
julia> print(meta)
Control:
  dense row parameter: 10.0
  aggressive absorption: 1.0
Info:
  status: ok
  matrix size: 10.0
  number of nonzeros: 54.0
  pattern symmetry: 0.5
  number of nonzeros on diagonal: 6.0
  number of nonzeros in A + A': 72.0
  number of dense columns: 0.0
  memory used: 1408.0
  number of garbage collections: 0.0
  approx number of nonzers in factor: 38.0
  number of float divides: 38.0
  number of float * or - for LDL: 114.0
  number of float * or - for LU: 190.0
  max nonzeros in any column of factor: 8.0
```

The **amd** algorithm computes a fill-reducing permutation based on the sparsity pattern of A + Aᵀ. The input pattern can be anything: diagonal entries will be ignored and the rest will be used to implicitly work on the pattern of A + Aᵀ. Thus if A is symmetric, it is sufficient to supply the strict lower or upper triangle only.

### References

1. P. R. Amestoy, T. A. Davis and I. S. Duff. An Approximate Minimum Degree
   Ordering Algorithm. *SIAM Journal on Matrix Analysis and Applications*, 17(4),
   pp. 886&ndash;905, 1996.
   DOI [10.1137/S0895479894278952](https://doi.org/10.1137/S0895479894278952)
2. P. R. Amestoy, T. A. Davis, and I. S. Duff. Algorithm 837: An approximate
   minimum degree ordering algorithm. *ACM Transactions on Mathematical
   Software*, 30(3), pp. 381&ndash;388, 2004.
   DOI [10.1145/1024074.1024081](https://doi.org/10.1145/1024074.1024081)
3. T. A. Davis, J. R. Gilbert, S. Larimore, E. Ng. Algorithm 836: COLAMD,
  an approximate column minimum degree ordering algorithm, *ACM
  Transactions on Mathematical Software*, 30(3), pp. 377&ndash;380, 2004.
  DOI [10.1145/1024074.1024080](https://doi.org/10.1145/1024074.1024080)

# Wrapping headers

This directory contains a script that can be used to automatically generate wrappers from C headers provided by the SuiteSparse libraries.
This is done using Clang.jl.

# Setup

You need to create an `include` folder that contains the header files `amd.h`, `camd.h`, `ccolamd.h`, `colamd.h` and `SuiteSparse_config.h`.

# Usage

Either run `julia wrapper.jl` directly, or include it and call the `main()` function.
Be sure to activate the project environment in this folder (`julia --project`), which will install `Clang.jl` and `JuliaFormatter.jl`.
You can also call `main(library)` if you want to generate the wrapper for a specific SuiteSparse `library`.
The possible values for `library` are:
- `"all"` (default);
- `"amd"`;
- `"camd"`;
- `"colamd"`;
- `"ccolamd"`.

function camd_order(n, Ap, Ai, P, Control, Info, C)
  @ccall libcamd.camd_order(
    n::Cint,
    Ap::Ptr{Cint},
    Ai::Ptr{Cint},
    P::Ptr{Cint},
    Control::Ptr{Cdouble},
    Info::Ptr{Cdouble},
    C::Ptr{Cint},
  )::Cint
end

function camd_l_order(n, Ap, Ai, P, Control, Info, C)
  @ccall libcamd.camd_l_order(
    n::SS_Int,
    Ap::Ptr{SS_Int},
    Ai::Ptr{SS_Int},
    P::Ptr{SS_Int},
    Control::Ptr{Cdouble},
    Info::Ptr{Cdouble},
    C::Ptr{SS_Int},
  )::SS_Int
end

function camd_2(
  n,
  Pe,
  Iw,
  Len,
  iwlen,
  pfree,
  Nv,
  Next,
  Last,
  Head,
  Elen,
  Degree,
  W,
  Control,
  Info,
  C,
  BucketSet,
)
  @ccall libcamd.camd_2(
    n::Cint,
    Pe::Ptr{Cint},
    Iw::Ptr{Cint},
    Len::Ptr{Cint},
    iwlen::Cint,
    pfree::Cint,
    Nv::Ptr{Cint},
    Next::Ptr{Cint},
    Last::Ptr{Cint},
    Head::Ptr{Cint},
    Elen::Ptr{Cint},
    Degree::Ptr{Cint},
    W::Ptr{Cint},
    Control::Ptr{Cdouble},
    Info::Ptr{Cdouble},
    C::Ptr{Cint},
    BucketSet::Ptr{Cint},
  )::Cvoid
end

function camd_l2(
  n,
  Pe,
  Iw,
  Len,
  iwlen,
  pfree,
  Nv,
  Next,
  Last,
  Head,
  Elen,
  Degree,
  W,
  Control,
  Info,
  C,
  BucketSet,
)
  @ccall libcamd.camd_l2(
    n::SS_Int,
    Pe::Ptr{SS_Int},
    Iw::Ptr{SS_Int},
    Len::Ptr{SS_Int},
    iwlen::SS_Int,
    pfree::SS_Int,
    Nv::Ptr{SS_Int},
    Next::Ptr{SS_Int},
    Last::Ptr{SS_Int},
    Head::Ptr{SS_Int},
    Elen::Ptr{SS_Int},
    Degree::Ptr{SS_Int},
    W::Ptr{SS_Int},
    Control::Ptr{Cdouble},
    Info::Ptr{Cdouble},
    C::Ptr{SS_Int},
    BucketSet::Ptr{SS_Int},
  )::Cvoid
end

function camd_valid(n_row, n_col, Ap, Ai)
  @ccall libcamd.camd_valid(n_row::Cint, n_col::Cint, Ap::Ptr{Cint}, Ai::Ptr{Cint})::Cint
end

function camd_l_valid(n_row, n_col, Ap, Ai)
  @ccall libcamd.camd_l_valid(
    n_row::SS_Int,
    n_col::SS_Int,
    Ap::Ptr{SS_Int},
    Ai::Ptr{SS_Int},
  )::SS_Int
end

function camd_cvalid(n, C)
  @ccall libcamd.camd_cvalid(n::Cint, C::Ptr{Cint})::Cint
end

function camd_l_cvalid(n, C)
  @ccall libcamd.camd_l_cvalid(n::SS_Int, C::Ptr{SS_Int})::SS_Int
end

function camd_defaults(Control)
  @ccall libcamd.camd_defaults(Control::Ptr{Cdouble})::Cvoid
end

function camd_l_defaults(Control)
  @ccall libcamd.camd_l_defaults(Control::Ptr{Cdouble})::Cvoid
end

function camd_control(Control)
  @ccall libcamd.camd_control(Control::Ptr{Cdouble})::Cvoid
end

function camd_l_control(Control)
  @ccall libcamd.camd_l_control(Control::Ptr{Cdouble})::Cvoid
end

function camd_info(Info)
  @ccall libcamd.camd_info(Info::Ptr{Cdouble})::Cvoid
end

function camd_l_info(Info)
  @ccall libcamd.camd_l_info(Info::Ptr{Cdouble})::Cvoid
end

const CAMD_CONTROL = 5
const CAMD_INFO = 20

const CAMD_DENSE = 1
const CAMD_AGGRESSIVE = 2
const CAMD_DEFAULT_DENSE = 10.0
const CAMD_DEFAULT_AGGRESSIVE = 2

const CAMD_STATUS = 1
const CAMD_N = 2
const CAMD_NZ = 3
const CAMD_SYMMETRY = 4
const CAMD_NZDIAG = 5
const CAMD_NZ_A_PLUS_AT = 6
const CAMD_NDENSE = 7
const CAMD_MEMORY = 8
const CAMD_NCMPA = 9
const CAMD_LNZ = 10
const CAMD_NDIV = 11
const CAMD_NMULTSUBS_LDL = 12
const CAMD_NMULTSUBS_LU = 13
const CAMD_DMAX = 14

const CAMD_OK = 0
const CAMD_OUT_OF_MEMORY = -1
const CAMD_INVALID = -2
const CAMD_OK_BUT_JUMBLED = 1

export Colamd, colamd, symamd

"""
    colamd(A)
    colamd(A, meta)

colamd computes a permutation vector `p` such that the Cholesky factorization of
  `A[:,p]' * A[:,p]` has less fill-in and requires fewer floating point operations than `AᵀA`.
"""
function colamd end

"""
    symamd(A)
    symamd(A, meta)

Given a symmetric or hermitian matrix `A`, symamd computes a permutation vector `p`
such that the Cholesky factorization of `A[p,p]` has less fill-in and
requires fewer floating point operations than that of A.
"""
function symamd end

const colamd_statuses = Dict(
  COLAMD_OK => "ok",
  COLAMD_OK_BUT_JUMBLED => "ok, but columns of input matrix were jumbled (unsorted columns or duplicate entries)",
  COLAMD_ERROR_A_not_present => "rowval is a null pointer",
  COLAMD_ERROR_p_not_present => "colptr is a null pointer",
  COLAMD_ERROR_nrow_negative => "nrow is negative",
  COLAMD_ERROR_ncol_negative => "nccol is negative",
  COLAMD_ERROR_nnz_negative => "number of nonzeros in matrix is negative",
  COLAMD_ERROR_p0_nonzero => "p[0] is nonzero",
  COLAMD_ERROR_A_too_small => "workspace is too small",
  COLAMD_ERROR_col_length_negative => "a column has a negative number of entries",
  COLAMD_ERROR_row_index_out_of_bounds => "a row index is out of bounds",
  COLAMD_ERROR_out_of_memory => "out of memory",
  COLAMD_ERROR_internal_error => "internal error",
)

mutable struct Colamd{T <: Union{Cint, SS_Int}}
  knobs::Vector{Cdouble}
  stats::Vector{T}

  function Colamd{T}() where {T <: Union{Cint, SS_Int}}
    knobs = zeros(Cdouble, COLAMD_KNOBS)
    stats = zeros(T, COLAMD_STATS)
    colamd_set_defaults(knobs)
    return new(knobs, stats)
  end
end

function show(io::IO, meta::Colamd)
  s = "dense row parameter: $(meta.knobs[COLAMD_DENSE_ROW])\n"
  s *= "dense col parameter: $(meta.knobs[COLAMD_DENSE_COL])\n"
  s *= "aggressive absorption: $(meta.knobs[COLAMD_AGGRESSIVE])\n"
  s *= "memory defragmentation: $(meta.stats[COLAMD_DEFRAG_COUNT])\n"
  s *= "status: $(colamd_statuses[meta.stats[COLAMD_STATUS]])\n"
  print(io, s)
end

print(io::IO, meta::Colamd) = show(io, meta)

for (fn, typ) in ((:colamd  , :Cint  ),
                  (:colamd_l, :SS_Int))

  Base.Sys.WORD_SIZE == 32 && fn == :colamd_l && continue
  @eval begin
    function colamd(A::SparseMatrixCSC{F, $typ}, meta::Colamd{$typ}) where {F}
      nrow, ncol = size(A)
      nnz = A.colptr[end] - 1
      p = A.colptr .- $typ(1)  # 0-based indexing
      len = colamd_recommended($typ(nnz), $typ(nrow), $typ(ncol))
      workspace = zeros($typ, len)
      workspace[1:length(A.rowval)] .= A.rowval .- $typ(1)
      valid = $fn(nrow, ncol, len, workspace, p, meta.knobs, meta.stats)
      Bool(valid) || throw("colamd status: $(colamd_statuses[meta.stats[COLAMD_STATUS]])")
      pop!(p)  # remove the number of nnz
      p .+= $typ(1)  # 1-based indexing
      return p
    end

    colamd(A::Symmetric{F, SparseMatrixCSC{F, $typ}}, meta::Colamd{$typ}) where {F} =
      colamd(A.data, meta)
    colamd(A::Hermitian{F, SparseMatrixCSC{F, $typ}}, meta::Colamd{$typ}) where {F} =
      colamd(A.data, meta)

    function colamd(A::SparseMatrixCSC{F, $typ}) where {F}
      meta = Colamd{$typ}()
      colamd(A, meta)
    end

    colamd(A::Symmetric{F, SparseMatrixCSC{F, $typ}}) where {F} = colamd(A.data)
    colamd(A::Hermitian{F, SparseMatrixCSC{F, $typ}}) where {F} = colamd(A.data)
  end
end

for (fn, typ) in ((:symamd  , :Cint  ),
                  (:symamd_l, :SS_Int))

  Base.Sys.WORD_SIZE == 32 && fn == :symamd_l && continue
  @eval begin
    function symamd(A::SparseMatrixCSC{F, $typ}, meta::Colamd{$typ}) where {F}
      nrow, ncol = size(A)
      colptr = A.colptr .- $typ(1)  # 0-based indexing
      rowval = A.rowval .- $typ(1)
      p = zeros($typ, nrow + 1) # p is used as a workspace during the ordering, which is why it must be of length n+1, not just n
      cfun_calloc = @cfunction(Base.Libc.calloc, Ptr{Cvoid}, ($typ, $typ))
      cfun_free = @cfunction(Base.Libc.free, Cvoid, (Ptr{Cvoid},))
      valid = $fn(nrow, rowval, colptr, p, meta.knobs, meta.stats, cfun_calloc, cfun_free)
      Bool(valid) || throw("symamd status: $(colamd_statuses[meta.stats[COLAMD_STATUS]])")
      pop!(p)
      p .+= $typ(1)  # 1-based indexing
      return p
    end

    symamd(A::Symmetric{F, SparseMatrixCSC{F, $typ}}, meta::Colamd{$typ}) where {F} =
      symamd(A.data, meta)
    symamd(A::Hermitian{F, SparseMatrixCSC{F, $typ}}, meta::Colamd{$typ}) where {F} =
      symamd(A.data, meta)

    function symamd(A::SparseMatrixCSC{F, $typ}) where {F}
      meta = Colamd{$typ}()
      symamd(A, meta)
    end

    symamd(A::Symmetric{F, SparseMatrixCSC{F, $typ}}) where {F} = symamd(A.data)
    symamd(A::Hermitian{F, SparseMatrixCSC{F, $typ}}) where {F} = symamd(A.data)
  end
end

using Pkg
bmark_dir = @__DIR__
Pkg.activate(bmark_dir)
Pkg.instantiate()
bmarkname = "AMD"
using Git

# if we are running these benchmarks from the git repository
# we want to develop the package instead of using the release
if isdir(joinpath(bmark_dir, "..", ".git"))
  Pkg.develop(PackageSpec(url = joinpath(bmark_dir, "..")))
  bmarkname = Git.head()  # sha of HEAD
end

using DataFrames
using GitHub
using JLD2
using JSON
using PkgBenchmark
using Plots

using SolverBenchmark

# NB: benchmarkpkg will run benchmarks/benchmarks.jl by default
commit = benchmarkpkg("AMD")  # current state of repository
main = benchmarkpkg("AMD", "main")
judgement = judge(commit, main)

commit_stats = bmark_results_to_dataframes(commit)
main_stats = bmark_results_to_dataframes(main)
judgement_stats = judgement_results_to_dataframes(judgement)

export_markdown("judgement_$(bmarkname).md", judgement)
export_markdown("main.md", main)
export_markdown("$(bmarkname).md", commit)

function profile_solvers_from_pkgbmark(stats::Dict{Symbol, DataFrame})
  # guard against zero gctimes
  costs =
    [df -> df[!, :time], df -> df[!, :memory], df -> df[!, :gctime] .+ 1, df -> df[!, :allocations]]
  profile_solvers(stats, costs, ["time", "memory", "gctime+1", "allocations"])
end

# extract stats for each benchmark to plot profiles
# files_dict will be part of json_dict below
files_dict = Dict{String, Any}()
file_num = 1
for k ∈ keys(judgement_stats)
  global file_num
  k_stats = Dict{Symbol, DataFrame}(:commit => commit_stats[k], :main => main_stats[k])
  save_stats(k_stats, "AMD_$(bmarkname)_vs_main_$(k).jld2", force = true)

  k_profile = profile_solvers_from_pkgbmark(k_stats)
  savefig("profiles_commit_vs_main_$(k).svg")
  # read contents of svg file to add to gist
  k_svgfile = open("profiles_commit_vs_main_$(k).svg", "r") do fd
    readlines(fd)
  end
  # file_num makes sure svg files appear before md files (added below)
  files_dict["$(file_num)_$(k).svg"] = Dict{String, Any}("content" => join(k_svgfile))
  file_num += 1
end

for mdfile ∈ [:judgement, :main, :commit]
  global file_num
  files_dict["$(file_num)_$(mdfile).md"] =
    Dict{String, Any}("content" => "$(sprint(export_markdown, eval(mdfile)))")
  file_num += 1
end

jldopen("AMD_$(bmarkname)_vs_main_judgement.jld2", "w") do file
  file["jstats"] = judgement_stats
end

# json description of gist
json_dict = Dict{String, Any}(
  "description" => "AMD repository benchmark",
  "public" => true,
  "files" => files_dict,
)

open("gist.json", "w") do f
  JSON.print(f, json_dict)
end

function amd_order(n, Ap, Ai, P, Control, Info)
  @ccall libamd.amd_order(
    n::Cint,
    Ap::Ptr{Cint},
    Ai::Ptr{Cint},
    P::Ptr{Cint},
    Control::Ptr{Cdouble},
    Info::Ptr{Cdouble},
  )::Cint
end

function amd_l_order(n, Ap, Ai, P, Control, Info)
  @ccall libamd.amd_l_order(
    n::SS_Int,
    Ap::Ptr{SS_Int},
    Ai::Ptr{SS_Int},
    P::Ptr{SS_Int},
    Control::Ptr{Cdouble},
    Info::Ptr{Cdouble},
  )::SS_Int
end

function amd_2(n, Pe, Iw, Len, iwlen, pfree, Nv, Next, Last, Head, Elen, Degree, W, Control, Info)
  @ccall libamd.amd_2(
    n::Cint,
    Pe::Ptr{Cint},
    Iw::Ptr{Cint},
    Len::Ptr{Cint},
    iwlen::Cint,
    pfree::Cint,
    Nv::Ptr{Cint},
    Next::Ptr{Cint},
    Last::Ptr{Cint},
    Head::Ptr{Cint},
    Elen::Ptr{Cint},
    Degree::Ptr{Cint},
    W::Ptr{Cint},
    Control::Ptr{Cdouble},
    Info::Ptr{Cdouble},
  )::Cvoid
end

function amd_l2(n, Pe, Iw, Len, iwlen, pfree, Nv, Next, Last, Head, Elen, Degree, W, Control, Info)
  @ccall libamd.amd_l2(
    n::SS_Int,
    Pe::Ptr{SS_Int},
    Iw::Ptr{SS_Int},
    Len::Ptr{SS_Int},
    iwlen::SS_Int,
    pfree::SS_Int,
    Nv::Ptr{SS_Int},
    Next::Ptr{SS_Int},
    Last::Ptr{SS_Int},
    Head::Ptr{SS_Int},
    Elen::Ptr{SS_Int},
    Degree::Ptr{SS_Int},
    W::Ptr{SS_Int},
    Control::Ptr{Cdouble},
    Info::Ptr{Cdouble},
  )::Cvoid
end

function amd_valid(n_row, n_col, Ap, Ai)
  @ccall libamd.amd_valid(n_row::Cint, n_col::Cint, Ap::Ptr{Cint}, Ai::Ptr{Cint})::Cint
end

function amd_l_valid(n_row, n_col, Ap, Ai)
  @ccall libamd.amd_l_valid(n_row::SS_Int, n_col::SS_Int, Ap::Ptr{SS_Int}, Ai::Ptr{SS_Int})::SS_Int
end

function amd_defaults(Control)
  @ccall libamd.amd_defaults(Control::Ptr{Cdouble})::Cvoid
end

function amd_l_defaults(Control)
  @ccall libamd.amd_l_defaults(Control::Ptr{Cdouble})::Cvoid
end

function amd_control(Control)
  @ccall libamd.amd_control(Control::Ptr{Cdouble})::Cvoid
end

function amd_l_control(Control)
  @ccall libamd.amd_l_control(Control::Ptr{Cdouble})::Cvoid
end

function amd_info(Info)
  @ccall libamd.amd_info(Info::Ptr{Cdouble})::Cvoid
end

function amd_l_info(Info)
  @ccall libamd.amd_l_info(Info::Ptr{Cdouble})::Cvoid
end

const AMD_CONTROL = 5
const AMD_INFO = 20

const AMD_DENSE = 1
const AMD_AGGRESSIVE = 2
const AMD_DEFAULT_DENSE = 10.0
const AMD_DEFAULT_AGGRESSIVE = 2

const AMD_STATUS = 1
const AMD_N = 2
const AMD_NZ = 3
const AMD_SYMMETRY = 4
const AMD_NZDIAG = 5
const AMD_NZ_A_PLUS_AT = 6
const AMD_NDENSE = 7
const AMD_MEMORY = 8
const AMD_NCMPA = 9
const AMD_LNZ = 10
const AMD_NDIV = 11
const AMD_NMULTSUBS_LDL = 12
const AMD_NMULTSUBS_LU = 13
const AMD_DMAX = 14

const AMD_OK = 0
const AMD_OUT_OF_MEMORY = -1
const AMD_INVALID = -2
const AMD_OK_BUT_JUMBLED = 1

# Script to parse SuiteSparse headers and generate Julia wrappers.
using Clang
using Clang.Generators
using JuliaFormatter

function wrapper(name::String, headers::Vector{String})
  @info "Wrapping $name"

  cd(@__DIR__)
  include_dir = joinpath(pwd(), "include")
  options = load_options(joinpath(@__DIR__, "generator.toml"))
  options["general"]["output_file_path"] = joinpath("..", "src", "wrappers", "$(name).jl")
  options["general"]["library_name"] = "lib" * name

  options["general"]["output_ignorelist"] = [
    "SuiteSparse_config_struct",
    "SuiteSparse_start",
    "SuiteSparse_finish",
    "SuiteSparse_malloc",
    "SuiteSparse_calloc",
    "SuiteSparse_realloc",
    "SuiteSparse_free",
    "SuiteSparse_tic",
    "SuiteSparse_toc",
    "SuiteSparse_time",
    "SuiteSparse_hypot",
    "SuiteSparse_divcomplex",
    "SuiteSparse_version",
    "SuiteSparse_long",
    "SuiteSparse_long_max",
    "SuiteSparse_long_idd",
    "SuiteSparse_long_id",
    "SUITESPARSE_DATE",
    "SUITESPARSE_VERSION",
    "SUITESPARSE_MAIN_VERSION",
    "SUITESPARSE_SUB_VERSION",
    "SUITESPARSE_SUBSUB_VERSION",
    "AMD_DATE",
    "AMD_VERSION",
    "AMD_MAIN_VERSION",
    "AMD_SUB_VERSION",
    "AMD_SUBSUB_VERSION",
    "CAMD_DATE",
    "CAMD_VERSION",
    "CAMD_MAIN_VERSION",
    "CAMD_SUB_VERSION",
    "CAMD_SUBSUB_VERSION",
    "COLAMD_DATE",
    "COLAMD_VERSION",
    "COLAMD_MAIN_VERSION",
    "COLAMD_SUB_VERSION",
    "COLAMD_SUBSUB_VERSION",
    "CCOLAMD_DATE",
    "CCOLAMD_VERSION",
    "CCOLAMD_MAIN_VERSION",
    "CCOLAMD_SUB_VERSION",
    "CCOLAMD_SUBSUB_VERSION",
  ]

  args = get_default_args()
  push!(args, "-I$include_dir")

  ctx = create_context(headers, args, options)
  build!(ctx)

  path = options["general"]["output_file_path"]
  format_file(path, YASStyle())

  text = read(path, String)
  text = replace(text, "Clong" => "SS_Int")
  text = replace(text, "end\n\nconst" => "end\n\n\nconst")
  text = replace(text, "\n\nconst" => "\nconst")
  write(path, text)
  return nothing
end

function main(name::String = "all")
  include = joinpath(pwd(), "include")

  if name == "all" || name == "amd"
    wrapper("amd", [joinpath(include, "amd.h")])
  end

  if name == "all" || name == "camd"
    wrapper("camd", [joinpath(include, "camd.h")])
  end

  if name == "all" || name == "colamd"
    wrapper("colamd", [joinpath(include, "colamd.h")])
  end

  if name == "all" || name == "ccolamd"
    wrapper("ccolamd", [joinpath(include, "ccolamd.h")])
  end
end

# If we want to use the file as a script with `julia wrapper.jl`
if abspath(PROGRAM_FILE) == @__FILE__
  main()
end

using LinearAlgebra
using SparseArrays
using Test
using Random

using AMD
import AMD: SS_Int, AMD_STATUS, AMD_OK, COLAMD_STATUS, COLAMD_OK

Random.seed!(666)

for n in [10, 20, 30]
  for density in [0.25, 0.75, 1.0]
    for T in [Cint, SS_Int]
      A = convert(SparseMatrixCSC{Float64, T}, sprand(n, n, density))
      @test amd_valid(A)

      meta = Amd()
      p = amd(A, meta)
      @test meta.info[AMD_STATUS] == AMD_OK
      @test minimum(p) == 1
      @test maximum(p) == n
      @test isperm(p)

      q = amd(A)
      @test all(p .== q)

      # test that amd(A) with A unsymmetric is amd(A + A')
      A = A + A'
      pA = amd(A)
      @test minimum(pA) == 1
      @test maximum(pA) == n
      @test isperm(pA)
    end
  end
end

for n in [10, 20, 30]
  for m in [10, 20, 30]
    for density in [0.25, 0.75, 1.0]
      for T in [Cint, SS_Int]
        A = convert(SparseMatrixCSC{Float64, T}, sprand(n, m, density))

        meta = Colamd{T}()
        p = colamd(A, meta)
        @test meta.stats[COLAMD_STATUS] == COLAMD_OK
        @test minimum(p) == 1
        @test maximum(p) == m
        @test isperm(p)
        q = colamd(A)
        @test all(p .== q)

        if n == m
          A = A * A'
          meta = Colamd{T}()
          p = symamd(A, meta)
          @test meta.stats[COLAMD_STATUS] == COLAMD_OK
          @test minimum(p) == 1
          @test maximum(p) == m
          @test isperm(p)

          q = symamd(A)
          @test all(p .== q)
        end
      end
    end
  end
end

# Test Symmetric and Hermitian wrappers
for ordering in (:amd, :symamd, :colamd)
  for wrapper in (:Symmetric, :Hermitian)
    for T in [Cint, SS_Int]
      @eval begin
        A = convert(SparseMatrixCSC{Float64, $T}, rand(10, 10))
        A = A * A'
        p = $ordering(A)

        L = $wrapper(A, :L)
        pL = $ordering(L)
        @test all(p .== pL)

        U = $wrapper(A, :U)
        pU = $ordering(U)
        @test all(p .== pU)
      end
    end
  end
end

# For coverage.
meta = Amd()
A = convert(SparseMatrixCSC{Float64, Cint}, sprand(10, 10, 0.5))
p = amd(A, meta)
show(meta)
print(meta)

meta = Colamd{Cint}()
p = colamd(A, meta)
show(meta)
print(meta)

function colamd_recommended(nnz, n_row, n_col)
  @ccall libcolamd.colamd_recommended(nnz::Cint, n_row::Cint, n_col::Cint)::Csize_t
end

function colamd_l_recommended(nnz, n_row, n_col)
  @ccall libcolamd.colamd_l_recommended(nnz::SS_Int, n_row::SS_Int, n_col::SS_Int)::Csize_t
end

function colamd_set_defaults(knobs)
  @ccall libcolamd.colamd_set_defaults(knobs::Ptr{Cdouble})::Cvoid
end

function colamd_l_set_defaults(knobs)
  @ccall libcolamd.colamd_l_set_defaults(knobs::Ptr{Cdouble})::Cvoid
end

function colamd(n_row, n_col, Alen, A, p, knobs, stats)
  @ccall libcolamd.colamd(
    n_row::Cint,
    n_col::Cint,
    Alen::Cint,
    A::Ptr{Cint},
    p::Ptr{Cint},
    knobs::Ptr{Cdouble},
    stats::Ptr{Cint},
  )::Cint
end

function colamd_l(n_row, n_col, Alen, A, p, knobs, stats)
  @ccall libcolamd.colamd_l(
    n_row::SS_Int,
    n_col::SS_Int,
    Alen::SS_Int,
    A::Ptr{SS_Int},
    p::Ptr{SS_Int},
    knobs::Ptr{Cdouble},
    stats::Ptr{SS_Int},
  )::SS_Int
end

function symamd(n, A, p, perm, knobs, stats, allocate, release)
  @ccall libcolamd.symamd(
    n::Cint,
    A::Ptr{Cint},
    p::Ptr{Cint},
    perm::Ptr{Cint},
    knobs::Ptr{Cdouble},
    stats::Ptr{Cint},
    allocate::Ptr{Cvoid},
    release::Ptr{Cvoid},
  )::Cint
end

function symamd_l(n, A, p, perm, knobs, stats, allocate, release)
  @ccall libcolamd.symamd_l(
    n::SS_Int,
    A::Ptr{SS_Int},
    p::Ptr{SS_Int},
    perm::Ptr{SS_Int},
    knobs::Ptr{Cdouble},
    stats::Ptr{SS_Int},
    allocate::Ptr{Cvoid},
    release::Ptr{Cvoid},
  )::SS_Int
end

function colamd_report(stats)
  @ccall libcolamd.colamd_report(stats::Ptr{Cint})::Cvoid
end

function colamd_l_report(stats)
  @ccall libcolamd.colamd_l_report(stats::Ptr{SS_Int})::Cvoid
end

function symamd_report(stats)
  @ccall libcolamd.symamd_report(stats::Ptr{Cint})::Cvoid
end

function symamd_l_report(stats)
  @ccall libcolamd.symamd_l_report(stats::Ptr{SS_Int})::Cvoid
end

const COLAMD_KNOBS = 20
const COLAMD_STATS = 20

const COLAMD_DENSE_ROW = 1
const COLAMD_DENSE_COL = 2
const COLAMD_AGGRESSIVE = 3
const COLAMD_DEFRAG_COUNT = 3
const COLAMD_STATUS = 4
const COLAMD_INFO1 = 5
const COLAMD_INFO2 = 6
const COLAMD_INFO3 = 7

const COLAMD_OK = 0
const COLAMD_OK_BUT_JUMBLED = 1

const COLAMD_ERROR_A_not_present = -1
const COLAMD_ERROR_p_not_present = -2
const COLAMD_ERROR_nrow_negative = -3
const COLAMD_ERROR_ncol_negative = -4
const COLAMD_ERROR_nnz_negative = -5
const COLAMD_ERROR_p0_nonzero = -6
const COLAMD_ERROR_A_too_small = -7
const COLAMD_ERROR_col_length_negative = -8
const COLAMD_ERROR_row_index_out_of_bounds = -9
const COLAMD_ERROR_out_of_memory = -10
const COLAMD_ERROR_internal_error = -999

function ccolamd_recommended(nnz, n_row, n_col)
  @ccall libccolamd.ccolamd_recommended(nnz::Cint, n_row::Cint, n_col::Cint)::Csize_t
end

function ccolamd_l_recommended(nnz, n_row, n_col)
  @ccall libccolamd.ccolamd_l_recommended(nnz::SS_Int, n_row::SS_Int, n_col::SS_Int)::Csize_t
end

function ccolamd_set_defaults(knobs)
  @ccall libccolamd.ccolamd_set_defaults(knobs::Ptr{Cdouble})::Cvoid
end

function ccolamd_l_set_defaults(knobs)
  @ccall libccolamd.ccolamd_l_set_defaults(knobs::Ptr{Cdouble})::Cvoid
end

function ccolamd(n_row, n_col, Alen, A, p, knobs, stats, cmember)
  @ccall libccolamd.ccolamd(
    n_row::Cint,
    n_col::Cint,
    Alen::Cint,
    A::Ptr{Cint},
    p::Ptr{Cint},
    knobs::Ptr{Cdouble},
    stats::Ptr{Cint},
    cmember::Ptr{Cint},
  )::Cint
end

function ccolamd_l(n_row, n_col, Alen, A, p, knobs, stats, cmember)
  @ccall libccolamd.ccolamd_l(
    n_row::SS_Int,
    n_col::SS_Int,
    Alen::SS_Int,
    A::Ptr{SS_Int},
    p::Ptr{SS_Int},
    knobs::Ptr{Cdouble},
    stats::Ptr{SS_Int},
    cmember::Ptr{SS_Int},
  )::SS_Int
end

function csymamd(n, A, p, perm, knobs, stats, allocate, release, cmember, stype)
  @ccall libccolamd.csymamd(
    n::Cint,
    A::Ptr{Cint},
    p::Ptr{Cint},
    perm::Ptr{Cint},
    knobs::Ptr{Cdouble},
    stats::Ptr{Cint},
    allocate::Ptr{Cvoid},
    release::Ptr{Cvoid},
    cmember::Ptr{Cint},
    stype::Cint,
  )::Cint
end

function csymamd_l(n, A, p, perm, knobs, stats, allocate, release, cmember, stype)
  @ccall libccolamd.csymamd_l(
    n::SS_Int,
    A::Ptr{SS_Int},
    p::Ptr{SS_Int},
    perm::Ptr{SS_Int},
    knobs::Ptr{Cdouble},
    stats::Ptr{SS_Int},
    allocate::Ptr{Cvoid},
    release::Ptr{Cvoid},
    cmember::Ptr{SS_Int},
    stype::SS_Int,
  )::SS_Int
end

function ccolamd_report(stats)
  @ccall libccolamd.ccolamd_report(stats::Ptr{Cint})::Cvoid
end

function ccolamd_l_report(stats)
  @ccall libccolamd.ccolamd_l_report(stats::Ptr{SS_Int})::Cvoid
end

function csymamd_report(stats)
  @ccall libccolamd.csymamd_report(stats::Ptr{Cint})::Cvoid
end

function csymamd_l_report(stats)
  @ccall libccolamd.csymamd_l_report(stats::Ptr{SS_Int})::Cvoid
end

function ccolamd2(
  n_row,
  n_col,
  Alen,
  A,
  p,
  knobs,
  stats,
  Front_npivcol,
  Front_nrows,
  Front_ncols,
  Front_parent,
  Front_cols,
  p_nfr,
  InFront,
  cmember,
)
  @ccall libccolamd.ccolamd2(
    n_row::Cint,
    n_col::Cint,
    Alen::Cint,
    A::Ptr{Cint},
    p::Ptr{Cint},
    knobs::Ptr{Cdouble},
    stats::Ptr{Cint},
    Front_npivcol::Ptr{Cint},
    Front_nrows::Ptr{Cint},
    Front_ncols::Ptr{Cint},
    Front_parent::Ptr{Cint},
    Front_cols::Ptr{Cint},
    p_nfr::Ptr{Cint},
    InFront::Ptr{Cint},
    cmember::Ptr{Cint},
  )::Cint
end

function ccolamd2_l(
  n_row,
  n_col,
  Alen,
  A,
  p,
  knobs,
  stats,
  Front_npivcol,
  Front_nrows,
  Front_ncols,
  Front_parent,
  Front_cols,
  p_nfr,
  InFront,
  cmember,
)
  @ccall libccolamd.ccolamd2_l(
    n_row::SS_Int,
    n_col::SS_Int,
    Alen::SS_Int,
    A::Ptr{SS_Int},
    p::Ptr{SS_Int},
    knobs::Ptr{Cdouble},
    stats::Ptr{SS_Int},
    Front_npivcol::Ptr{SS_Int},
    Front_nrows::Ptr{SS_Int},
    Front_ncols::Ptr{SS_Int},
    Front_parent::Ptr{SS_Int},
    Front_cols::Ptr{SS_Int},
    p_nfr::Ptr{SS_Int},
    InFront::Ptr{SS_Int},
    cmember::Ptr{SS_Int},
  )::SS_Int
end

function ccolamd_apply_order(Front, Order, Temp, nn, nfr)
  @ccall libccolamd.ccolamd_apply_order(
    Front::Ptr{Cint},
    Order::Ptr{Cint},
    Temp::Ptr{Cint},
    nn::Cint,
    nfr::Cint,
  )::Cvoid
end

function ccolamd_l_apply_order(Front, Order, Temp, nn, nfr)
  @ccall libccolamd.ccolamd_l_apply_order(
    Front::Ptr{SS_Int},
    Order::Ptr{SS_Int},
    Temp::Ptr{SS_Int},
    nn::SS_Int,
    nfr::SS_Int,
  )::Cvoid
end

function ccolamd_fsize(nn, MaxFsize, Fnrows, Fncols, Parent, Npiv)
  @ccall libccolamd.ccolamd_fsize(
    nn::Cint,
    MaxFsize::Ptr{Cint},
    Fnrows::Ptr{Cint},
    Fncols::Ptr{Cint},
    Parent::Ptr{Cint},
    Npiv::Ptr{Cint},
  )::Cvoid
end

function ccolamd_l_fsize(nn, MaxFsize, Fnrows, Fncols, Parent, Npiv)
  @ccall libccolamd.ccolamd_l_fsize(
    nn::SS_Int,
    MaxFsize::Ptr{SS_Int},
    Fnrows::Ptr{SS_Int},
    Fncols::Ptr{SS_Int},
    Parent::Ptr{SS_Int},
    Npiv::Ptr{SS_Int},
  )::Cvoid
end

function ccolamd_postorder(
  nn,
  Parent,
  Npiv,
  Fsize,
  Order,
  Child,
  Sibling,
  Stack,
  Front_cols,
  cmember,
)
  @ccall libccolamd.ccolamd_postorder(
    nn::Cint,
    Parent::Ptr{Cint},
    Npiv::Ptr{Cint},
    Fsize::Ptr{Cint},
    Order::Ptr{Cint},
    Child::Ptr{Cint},
    Sibling::Ptr{Cint},
    Stack::Ptr{Cint},
    Front_cols::Ptr{Cint},
    cmember::Ptr{Cint},
  )::Cvoid
end

function ccolamd_l_postorder(
  nn,
  Parent,
  Npiv,
  Fsize,
  Order,
  Child,
  Sibling,
  Stack,
  Front_cols,
  cmember,
)
  @ccall libccolamd.ccolamd_l_postorder(
    nn::SS_Int,
    Parent::Ptr{SS_Int},
    Npiv::Ptr{SS_Int},
    Fsize::Ptr{SS_Int},
    Order::Ptr{SS_Int},
    Child::Ptr{SS_Int},
    Sibling::Ptr{SS_Int},
    Stack::Ptr{SS_Int},
    Front_cols::Ptr{SS_Int},
    cmember::Ptr{SS_Int},
  )::Cvoid
end

function ccolamd_post_tree(root, k, Child, Sibling, Order, Stack)
  @ccall libccolamd.ccolamd_post_tree(
    root::Cint,
    k::Cint,
    Child::Ptr{Cint},
    Sibling::Ptr{Cint},
    Order::Ptr{Cint},
    Stack::Ptr{Cint},
  )::Cint
end

function ccolamd_l_post_tree(root, k, Child, Sibling, Order, Stack)
  @ccall libccolamd.ccolamd_l_post_tree(
    root::SS_Int,
    k::SS_Int,
    Child::Ptr{SS_Int},
    Sibling::Ptr{SS_Int},
    Order::Ptr{SS_Int},
    Stack::Ptr{SS_Int},
  )::SS_Int
end

const CCOLAMD_KNOBS = 20
const CCOLAMD_STATS = 20

const CCOLAMD_DENSE_ROW = 1
const CCOLAMD_DENSE_COL = 2
const CCOLAMD_AGGRESSIVE = 3
const CCOLAMD_LU = 4
const CCOLAMD_DEFRAG_COUNT = 3
const CCOLAMD_STATUS = 4
const CCOLAMD_INFO1 = 5
const CCOLAMD_INFO2 = 6
const CCOLAMD_INFO3 = 7
const CCOLAMD_EMPTY_ROW = 8
const CCOLAMD_EMPTY_COL = 9
const CCOLAMD_NEWLY_EMPTY_ROW = 10
const CCOLAMD_NEWLY_EMPTY_COL = 11

const CCOLAMD_OK = 0
const CCOLAMD_OK_BUT_JUMBLED = 1

const CCOLAMD_ERROR_A_not_present = -1
const CCOLAMD_ERROR_p_not_present = -2
const CCOLAMD_ERROR_nrow_negative = -3
const CCOLAMD_ERROR_ncol_negative = -4
const CCOLAMD_ERROR_nnz_negative = -5
const CCOLAMD_ERROR_p0_nonzero = -6
const CCOLAMD_ERROR_A_too_small = -7
const CCOLAMD_ERROR_col_length_negative = -8
const CCOLAMD_ERROR_row_index_out_of_bounds = -9
const CCOLAMD_ERROR_out_of_memory = -10
const CCOLAMD_ERROR_invalid_cmember = -11
const CCOLAMD_ERROR_internal_error = -999

using Pkg
Pkg.activate("./benchmark/")
Pkg.instantiate()

using ArgParse
using Git
using GitHub
using Printf
using JSON

DEFAULT_GIST_FILE_PATH = "./gist.json"

function parse_commandline()
  s = ArgParseSettings()
  @add_arg_table! s begin
    "--org", "-o"
    help = "Name of GitHub Organization"
    arg_type = String
    default = "ProofOfConceptForJuliSmoothOptimizers"
    "--repo", "-r"
    help = "The name of the repository on GitHub"
    arg_type = String
    required = true
    "--pullrequest", "-p"
    help = "An integer that corresponds to the pull request"
    required = true
    arg_type = Int
    "--gist", "-g"
    help = "specify this argument if you want to send a gist to the pullrequest. If this option is not specified, you must specify a comment"
    action = :store_true

    "--comment", "-c"
    help = "Comment to post on the pull request"
    arg_type = String
    required = false
  end

  return parse_args(s, as_symbols = true)
end

function create_gist_from_json_file(myauth)
  gistfile = DEFAULT_GIST_FILE_PATH
  gist = begin
    open(gistfile, "r") do f
      return JSON.parse(f)
    end
  end
  posted_gist = create_gist(params = gist, auth = myauth)
  return posted_gist
end

function get_repo(api::GitHub.GitHubWebAPI, org::String, repo_name::String; kwargs...)
  my_params = Dict(:visibility => "all")
  # return GitHub.repo(api, repo; params = my_params, kwargs...)
  return Repo(GitHub.gh_get_json(api, "/repos/$(org)/$(repo_name)"; params = my_params, kwargs...))
end

function get_pull_request(
  api::GitHub.GitHubWebAPI,
  org::String,
  repo::Repo,
  pullrequest_id;
  kwargs...,
)
  my_params = Dict(:sort => "popularity", :direction => "desc")
  pull_request = PullRequest(
    GitHub.gh_get_json(
      api,
      "/repos/$(org)/$(repo.name)/pulls/$(pullrequest_id)";
      params = my_params,
      kwargs...,
    ),
  )
  return pull_request
end

function post_comment_to_pr(
  org::String,
  repo_name::String,
  pullrequest_id::Int,
  comment::String;
  kwargs...,
)
  api = GitHub.DEFAULT_API
  repo = get_repo(api, org, repo_name; kwargs...)
  pull_request = get_pull_request(api, org, repo, pullrequest_id; kwargs...)
  GitHub.create_comment(api, repo, pull_request, comment; kwargs...)
end

function main()
  # Need to add GITHUB_AUTH to your .bashrc
  myauth = GitHub.authenticate(ENV["GITHUB_AUTH"])
  # parse the arguments: 
  parsed_args = parse_commandline()
  org = parsed_args[:org]
  repo_name = parsed_args[:repo]
  pullrequest_id = parsed_args[:pullrequest]
  gist_flag = parsed_args[:gist]
  comment =
    gist_flag ?
    "The gist of the benchmarks can be found here: $(create_gist_from_json_file(myauth).html_url)" :
    parsed_args[:comment]
  post_comment_to_pr(org, repo_name, pullrequest_id, comment; auth = myauth)
end

main()

using BenchmarkTools
using DelimitedFiles, LinearAlgebra, Printf, SparseArrays
using Pkg.Artifacts

using MatrixMarket
using Metis, SymRCM, AMD
using LDLFactorizations, SolverBenchmark

const SUITE = BenchmarkGroup()
SUITE["no_ordering"] = BenchmarkGroup()
SUITE["amd"] = BenchmarkGroup()
SUITE["symamd"] = BenchmarkGroup()
SUITE["metis"] = BenchmarkGroup()
SUITE["symrcm"] = BenchmarkGroup()

# obtain path to SQD collection
const artifact_toml = joinpath(@__DIR__, "Artifacts.toml")
ensure_artifact_installed("sqdcollection", artifact_toml)
const sqd_hash = artifact_hash("sqdcollection", artifact_toml)
@assert artifact_exists(sqd_hash)
const sqd_path = joinpath(artifact_path(sqd_hash), "sqd-collection-0.1")

subdirs = readdir(sqd_path)
const formulations = ["2x2", "3x3"]

names_sqd = String[]
ratio_amd = Float64[]
ratio_symamd = Float64[]
ratio_metis = Float64[]
ratio_symrcm = Float64[]
ratio_classic = Float64[]
nnz_sqd = Int[]

for subdir ∈ subdirs
  subdir == ".git" && continue
  isdir(joinpath(sqd_path, subdir)) || continue  # ignore regular files
  for formulation ∈ formulations
    iterpath = joinpath(sqd_path, subdir, formulation, "iter_0")
    isdir(iterpath) || continue

    A = MatrixMarket.mmread(joinpath(iterpath, "K_0.mtx"))
    b = readdlm(joinpath(iterpath, "rhs_0.rhs"), Float64)[:]
    nnz_A = nnz(tril(A, -1))
    n = size(A, 1)
    if n ≤ 25000
      name = "$(subdir)_$(formulation)"
      push!(names_sqd, name)

      p_amd = amd(A)
      p_symamd = symamd(A)
      p_metis, _ = Metis.permutation(A)
      p_symrcm = symrcm(A)
      p_classic = collect(1:n)
      println(name)

      SUITE["no_ordering"][name] = @benchmarkable nnz(ldl($A, $p_classic).L) / $nnz_A
      SUITE["amd"][name] = @benchmarkable nnz(ldl($A, $p_amd).L) / $nnz_A
      SUITE["symamd"][name] = @benchmarkable nnz(ldl($A, $p_symamd).L) / $nnz_A
      SUITE["metis"][name] = @benchmarkable nnz(ldl($A, $p_metis).L) / $nnz_A
      SUITE["symrcm"][name] = @benchmarkable nnz(ldl($A, $p_symrcm).L) / $nnz_A
    end
  end
end

module AMD

using LinearAlgebra
using SparseArrays
using SuiteSparse_jll

import Base.show, Base.print

SS_Int = Base.Sys.WORD_SIZE == 32 ? Int32 : Int64

include("wrappers/amd.jl")
include("wrappers/camd.jl")
include("wrappers/colamd.jl")
include("wrappers/ccolamd.jl")

include("amd_julia.jl")
include("colamd_julia.jl")

end # module

export Amd, amd_valid, amd

"""
    amd(A)
    amd(A, meta)

Given a sparse matrix `A` and an `Amd` structure `meta`, `p = amd(A, meta)` computes the approximate minimum degree ordering of `A + Aᵀ`.
The ordering is represented as a permutation vector `p`.
Factorizations of `A[p,p]` tend to be sparser than those of `A`.

The matrix `A` must be square and the sparsity pattern of `A + Aᵀ` is implicit.
Thus it is convenient to represent symmetric or hermitian matrices using one triangle only.
The diagonal of `A` may be present but will be ignored.

The ordering may be influenced by changing `meta.control[AMD_DENSE]` and `meta.control[AMD_AGGRESSIVE]`.

Statistics on the ordering appear in `meta.info`.
"""
function amd end

const amd_statuses = Dict(
  AMD_OK => "ok",
  AMD_OUT_OF_MEMORY => "out of memory",
  AMD_INVALID => "input invalid",
  AMD_OK_BUT_JUMBLED => "ok but jumbled",
)

"""
Base type to hold control and information related to a call to AMD.
`control` is a `Vector{Float64}` with components:

* d = control[AMD_DENSE]: rows with more than max(d√n, 16) entries are considered "dense" and appear last in the permutation.
If d < 0 no row will be treated as dense.

* control[AMD_AGGRESSIVE]: triggers aggressive absorption if nonzero.

`info` is a `Vector{Float64}` that contains statistics on the ordering.
"""
mutable struct Amd
  control::Vector{Cdouble}
  info::Vector{Cdouble}

  function Amd()
    control = zeros(Cdouble, AMD_CONTROL)
    info = zeros(Cdouble, AMD_INFO)
    amd_defaults(control)
    return new(control, info)
  end
end

function show(io::IO, meta::Amd)
  s = "Control:\n"
  s *= "  dense row parameter: $(meta.control[AMD_DENSE])\n"
  s *= "  aggressive absorption: $(meta.control[AMD_AGGRESSIVE])\n"
  s *= "Info:\n"
  s *= "  status: $(amd_statuses[meta.info[AMD_STATUS]])\n"
  s *= "  matrix size: $(meta.info[AMD_N])\n"
  s *= "  number of nonzeros: $(meta.info[AMD_NZ])\n"
  s *= "  pattern symmetry: $(meta.info[AMD_SYMMETRY])\n"
  s *= "  number of nonzeros on diagonal: $(meta.info[AMD_NZDIAG])\n"
  s *= "  number of nonzeros in A + Aᵀ: $(meta.info[AMD_NZ_A_PLUS_AT])\n"
  s *= "  number of dense columns: $(meta.info[AMD_NDENSE])\n"
  s *= "  memory used: $(meta.info[AMD_MEMORY])\n"
  s *= "  number of garbage collections: $(meta.info[AMD_NCMPA])\n"
  s *= "  approx number of nonzers in factor: $(meta.info[AMD_LNZ])\n"
  s *= "  number of float divides: $(meta.info[AMD_NDIV])\n"
  s *= "  number of float * or - for LDL: $(meta.info[AMD_NMULTSUBS_LDL])\n"
  s *= "  number of float * or - for LU: $(meta.info[AMD_NMULTSUBS_LU])\n"
  s *= "  max nonzeros in any column of factor: $(meta.info[AMD_DMAX])\n"
  print(io, s)
end

print(io::IO, meta::Amd) = show(io, meta)

for (validfn, typ) in ((:amd_valid,   :Cint  ),
                       (:amd_l_valid, :SS_Int))

  Base.Sys.WORD_SIZE == 32 && validfn == :amd_l_valid && continue
  @eval begin
    function amd_valid(A::SparseMatrixCSC{F, $typ}) where {F}
      nrow, ncol = size(A)
      colptr = A.colptr .- $typ(1)  # 0-based indexing
      rowval = A.rowval .- $typ(1)
      valid = $validfn(nrow, ncol, colptr, rowval)
      return valid == AMD_OK || valid == AMD_OK_BUT_JUMBLED
    end

    amd_valid(A::Symmetric{F, SparseMatrixCSC{F, $typ}}) where {F} = amd_valid(A.data)
    amd_valid(A::Hermitian{F, SparseMatrixCSC{F, $typ}}) where {F} = amd_valid(A.data)
  end
end

for (orderfn, typ) in ((:amd_order  , :Cint  ),
                       (:amd_l_order, :SS_Int))

  Base.Sys.WORD_SIZE == 32 && orderfn == :amd_l_order && continue
  @eval begin
    function amd(A::SparseMatrixCSC{F, $typ}, meta::Amd) where {F}
      nrow, ncol = size(A)
      nrow == ncol || error("AMD: input matrix must be square")
      colptr = A.colptr .- $typ(1)  # 0-based indexing
      rowval = A.rowval .- $typ(1)

      p = zeros($typ, nrow)
      valid = $orderfn(nrow, colptr, rowval, p, meta.control, meta.info)
      (valid == AMD_OK || valid == AMD_OK_BUT_JUMBLED) ||
        throw("amd_order returns: $(amd_statuses[valid])")
      p .+= 1
      return p
    end

    amd(A::Symmetric{F, SparseMatrixCSC{F, $typ}}, meta::Amd) where {F} = amd(A.data, meta)
    amd(A::Hermitian{F, SparseMatrixCSC{F, $typ}}, meta::Amd) where {F} = amd(A.data, meta)

    function amd(A::SparseMatrixCSC{F, $typ}) where {F}
      meta = Amd()
      amd(A, meta)
    end

    amd(A::Symmetric{F, SparseMatrixCSC{F, $typ}}) where {F} = amd(A.data)
    amd(A::Hermitian{F, SparseMatrixCSC{F, $typ}}) where {F} = amd(A.data)
  end
end

#!/bin/bash

julia benchmark/send_comment_to_pr.jl -o $org -r $repo -p $pullrequest -c '**Starting benchmarks!**'  

if julia benchmark/run_benchmarks.jl $1 ; then
    julia benchmark/send_comment_to_pr.jl -o $org -r $repo -p $pullrequest -g
else
    julia benchmark/send_comment_to_pr.jl -o $org -r $repo -p $pullrequest -c "**An error has occured while running the benchmarks in file $1** "
fi
